

var motor=0;

    
    function addText(data) 
    {
     if($("#comment").length)   
     document.getElementById("comment").value += data;
    }
    
    
    var socket = io.connect();


    function ssend(s)
    {
     s=s+"\n";   
     socket.send(s);   
     addText(">"+s);    
    }

    function ssend2(s)
    {
     s=s.replace(/(\r\n|\n|\r)/gm,"");
     ssend(s);
    }

    socket.on('error', function() {
        console.log('Got error');
    });


    
function rxmovelo(lmotor,steps)
{
 var s=steps.toString();   
    
 if(motor==lmotor)
 {
  $('#dist_tb').val("");
  $('#dist_tb').attr("placeholder",s);
 }

 if(lmotor==0) $('#m0pos_tb').val(s);
 if(lmotor==1) $('#m1pos_tb').val(s);
 if(lmotor==2) $('#m2pos_tb').val(s);              
}


function motorposn(lmotor)
{
 if(lmotor==0) return(parseInt($('#m0pos_tb').val()));
 if(lmotor==1) return(parseInt($('#m1pos_tb').val()));
 if(lmotor==2) return(parseInt($('#m2pos_tb').val()));              
 return(0);
}


function rxmove(command)
{
 var lmotor=parseInt(command[1]);
 var steps=parseInt(command[2]);
 rxmovelo(lmotor,steps);
}


function rxspeed(command)
{
 var lmotor=parseInt(command[1]);
 var steps=parseInt(command[2]);
 var i;
 var obj;
 var s;
 
 state.motor[lmotor].speed=steps;

 for(i=0;i<presetids.length;i++)
 {
  obj=presetspane[presetids[i]];
  if(obj.motor==lmotor && obj.statename=="speed")
  {
   s=obj.writer(steps);
   $('#'+presetids[i]).val(s);   
  }
 }
}



function rxacceleration(command)
{
 var lmotor=parseInt(command[1]);
 var steps=parseInt(command[2]);
 var i;
 var obj;
 var s;
 
 state.motor[lmotor].acceleration=steps;

 for(i=0;i<presetids.length;i++)
 {
  obj=presetspane[presetids[i]];
  if(obj.motor==lmotor && obj.statename=="acceleration")
  {
   s=obj.writer(steps);
   $('#'+presetids[i]).val(s);   
  }
 }
 
}



function rxstepsize(command)
{
 var lmotor=parseInt(command[1]);
 var steps=parseInt(command[2]);
 var i;
 var obj;
 var s;
 
 state.motor[lmotor].stepsize=steps;

 for(i=0;i<presetids.length;i++)
 {
  obj=presetspane[presetids[i]];
  if(obj.motor==lmotor && obj.statename=="stepsize")
  {
   s=obj.writer(steps);
   $('#'+presetids[i]).val(s);   
  }
 }
 
}

var statename=[
"Stopped",// RSTATE_STOPPED 0
"Fire 1", // RSTATE_FIRE1 1
"Fire 2", // RSTATE_FIRE2 2
"Waiting", // RSTATE_WAITING 3
"Settle", // RSTATE_SETTLE
"Fire 3", // RSTATE_FIRE3 5
"Fire 4", // RSTATE_FIRE4 6
"Motor setup", // RSTATE_MOTORS_SETUP 7
"Motor poll", //RSTATE_MOTORS_POLL 8    
    
    
    
];


function rxsequencestatus(command)
{
 var state=parseInt(command[1]);
 var steps=parseInt(command[3]);
 var noofimages=sequencevalues["NoOfImages"];
 
 $('#progbar_pb').attr('aria-valuenow',(100*steps)/noofimages);
 $('#progbar_pb').attr('style',"width: "+((100*steps)/noofimages).toString()+"%");
 $('#progbar_pb').text(((100*steps)/noofimages).toString()+"%");
 $('#info_tb').val(statename[state]);
}




function rxsequencevalues(command)
{
 var noofimages=parseInt(command[1]);
 var stepsperimage=parseInt(command[2]);
 var sequenceduration=parseInt(command[3]);
 var camerasettletime=parseInt(command[4]);
 var exposuredelay=parseInt(command[5]);
 var i;
 var s;
 var obj;
    
 sequencevalues["NoOfImages"]=noofimages;
 sequencevalues["StepsPerImage"]=stepsperimage;
 sequencevalues["DurationOfRun"]=sequenceduration;
 sequencevalues["CameraSettleTime"]=camerasettletime;
 sequencevalues["ExposureDelay"]=exposuredelay;
 
 for(i=0;i<sequenceids.length;i++)
 {
  obj=sequencepane[sequenceids[i]];
  s=obj.writer(sequencevalues[obj.name]);
  $('#'+sequenceids[i]).val(s);   
 }
}


function rxsequencevalues2(command)
{
 var firebuttondelay=parseInt(command[1]);
 var i;
 var s;
 var obj;

 sequencevalues["FireButtonDelay"]=firebuttondelay;

 for(i=0;i<sequenceids.length;i++)
 {
  obj=sequencepane[sequenceids[i]];
  s=obj.writer(sequencevalues[obj.name]);
  $('#'+sequenceids[i]).val(s);   
 }
}    



function updatesequencemotorvalue(name,lmotor)
{
 var i;
 var obj;

 for(i=0;i<seqsetids.length;i++)
 {
  obj=seqsetuppane[seqsetids[i]];
  if(obj)
  {    
   if(obj.name==name && obj.motor==lmotor)
   {
    if(obj.writer==writecheckbox)
    {
     s=obj.writer(seqsetvalues.motor[lmotor][obj.name]);  
     $('#'+seqsetids[i]).prop('checked',s);   
    }
    else
    {    
     s=obj.writer(seqsetvalues.motor[lmotor][obj.name]);
     $('#'+seqsetids[i]).val(s);
    }
   } 
  }
 }
}



function rxsequencemotorvalues(command)
{
 var motor=parseInt(command[1]);
 var i;
 var s;
 var obj;
 var f;
 
 
 seqsetvalues.motor[motor].Use=parseInt(command[2]);
 seqsetvalues.motor[motor].MoveIn=parseInt(command[3]);
 seqsetvalues.motor[motor].StepLength=parseInt(command[4]);
 seqsetvalues.motor[motor].DelayBeforeFirstMove=parseInt(command[5]);
 seqsetvalues.motor[motor].RampUp=parseInt(command[6]);
 seqsetvalues.motor[motor].NumberOfSteps=parseInt(command[7]);
 seqsetvalues.motor[motor].DelayAfterLastMove=parseInt(command[8]);
 seqsetvalues.motor[motor].RampDown=parseInt(command[9]);
       
 for(i=0;i<seqsetids.length;i++)
 {
  obj=seqsetuppane[seqsetids[i]];
  if(obj)
  {    
   if(obj.motor==motor)
   {
    if(obj.writer==writecheckbox)
    {
     s=obj.writer(seqsetvalues.motor[motor][obj.name]);  
     $('#'+seqsetids[i]).prop('checked',s);   
    }
    else
    {    
     s=obj.writer(seqsetvalues.motor[motor][obj.name]);
     $('#'+seqsetids[i]).val(s);
    }
   } 
  }
 }
}




var stack=[];

function rxls(command)
{
 var index;
 
 index=parseInt(command[1]);
 if(index==0) stack.length=0;

 stack.push(command[2]);
}


function rxsave(command)
{
 alert("Configuration saved");
 if(stack.indexOf(command[1])<0) stack.push(command[1]);
 stack.sort();
 
 
}



function rxshutdown(command)
{
 socket.disconnect();
}


    
var commandtable={"sa":rxsave,"ls":rxls,"mv":rxmove,"ps":rxmove,"sp":rxspeed,"ac":rxacceleration,
"ss":rxstepsize,"qq":rxsequencestatus,
"qv":rxsequencevalues,"qm":rxsequencemotorvalues,"qw":rxsequencevalues2,"sd":rxshutdown};


        
var currentstring="";

socket.on('message', function(data) 
{
 currentstring=currentstring+data;
 var n;
 while((n=currentstring.indexOf("\n"))>=0)
 {
  var s=currentstring.substr(0,n);
  addText("<"+s+"\n");
  currentstring=currentstring.substr(n+1);
  var command=s.split(" ");
  if(commandtable[command[0]]) commandtable[command[0]](command);
 }
});       

    
        
$("#usr").keypress(function(e)
{
 if(e.which==13) 
 {
  ssend2($('#usr').val());
 }
});

    
    
     
    
 
    
state={"motor":[{"stepsize":4,"timode":0,"speed":12000,"acceleration":20000},
                {"stepsize":4,"timode":0,"speed":12000,"acceleration":20000},
                {"stepsize":2,"timode":0,"speed":12000,"acceleration":20000}
               ]};
    

function RunSpeed(motor,speed)
{
 ssend("rs "+motor.toString()+" "+speed.toString());    
}
    
    function SetSpeedMotor(motor,speed)
    {
     ssend("sp "+motor.toString()+" "+speed.toString());    
     state.motor[motor].speed=speed;        
    }
    
    function SetAccelerationMotor(motor,acc)
    {
     ssend("ac "+motor.toString()+" "+acc.toString());    
    }
    
    function MoveMotor(motor,steps)
    {
     ssend("mv "+motor.toString()+" "+steps.toString());    
    }
    
    function MoveToMotor(motor,steps)
    {
     ssend("mt "+motor.toString()+" "+steps.toString());            
    }
    
    function StopMotor(motor)
    {
     ssend("xx "+motor.toString());
    }

    function SetCurPos(motor,steps)
    {
     ssend("sc "+motor.toString()+" "+steps.toString());                    
    }
    
    function StepSizeMotor(motor,steps)
    {
     ssend("ss "+motor.toString()+" "+steps.toString());   
    }
    
    function PowerMotor(motor,pw)
    {
     ssend("pw "+motor.toString()+" "+pw.toString());           
    }

    function WritePin(pin,value)
    {
     ssend("wr "+pin.toString()+" "+value.toString());        
    }
    
    function ArmInterrupt(motor,interrupt,mode)
    {
     ssend("ai "+motor.toString()+" "+interrupt.toString()+" "+mode.toString());
    }

    function RemInterrupt(motor,interrupt)
    {
     ssend("ai "+motor.toString()+" "+interrupt.toString());
    }
    
    function SendCommand(command)
    {
     ssend(command);   
    }    
        
    function GetResponse(command,delay)
    {
     ssend(command);
     
    }
    
    function GetPosition(motor)
    {
     ssend("ps "+motor.toString());
        
    }
    
    function GetDistanceToGo(motor)
    {
     ssend("ds "+motor.toString());   
    }
    
    function ReadPin(pin)
    {
     ssend("rd "+pin.toString());      
        
    }
    
    function TestMoveOver(motor,delay)
    {
//See if a move has completed, returns non-zero on success. Returns position after move. delay is time to wait for a result in ms.        
        
    }
    








$("#motor_rb :input").change(function() 
{
 motor=parseInt(this.value); // points to the clicked input button
 writewaypoints();
});


    
$("#run_btn").click(function()
{
 if($('#dist_tb').val()!="")
 {
  flushmotorchanges();
  MoveMotor(motor,parseInt($('#dist_tb').val()));
 }
});


$("#dist_tb").keypress(function(e) 
{
 if(e.which == 13) 
 {
  if($('#dist_tb').val()!="")
  {
   flushmotorchanges();   
   MoveMotor(motor,parseInt($('#dist_tb').val()));
  }
 }
});
    

$("#gtz_btn").click(function()
{
 flushmotorchanges();
 MoveToMotor(motor,0);
});


$("#stz_btn").click(function()
{
 SetCurPos(motor,0);
 rxmovelo(motor,0); 
});


$("#mvin_btn").bind("touchstart mousedown",function()
{
 flushmotorchanges();    
 RunSpeed(motor,-state.motor[motor].speed);
});


$("#mvin_btn").bind("touchend mouseup",function()
{
 RunSpeed(motor,0);
 GetPosition(motor);
});


$("#mvout_btn").bind("touchstart mousedown",function()
{
 flushmotorchanges();
 RunSpeed(motor,state.motor[motor].speed);
});


$("#mvout_btn").bind("touchend mouseup",function()
{
 RunSpeed(motor,0);
 GetPosition(motor);
});



function readint(s)
{
 return(parseInt(s));   
}


function writeint(i)
{
 return(i.toString());   
}

function readfloat(s)
{
 var v=parseFloat(s);
 
 v=v*1000;
    
 return(Math.round(v));   
}


function writefloat(i)
{
 var v=i/1000;   
    
 return(v.toString());   
}



presetspane={
"m0sp_tb":{"motor":0,"statename":"speed","change":1,"reader":readint,"setfunction":SetSpeedMotor,"writer":writeint},
"m0ac_tb":{"motor":0,"statename":"acceleration","change":1,"reader":readint,"setfunction":SetAccelerationMotor,"writer":writeint},
"m0sm_tb":{"motor":0,"statename":"stepsize","change":1,"reader":readint,"setfunction":StepSizeMotor,"writer":writeint},

"m1sp_tb":{"motor":1,"statename":"speed","change":1,"reader":readint,"setfunction":SetSpeedMotor,"writer":writeint},
"m1ac_tb":{"motor":1,"statename":"acceleration","change":1,"reader":readint,"setfunction":SetAccelerationMotor,"writer":writeint},
"m1sm_tb":{"motor":1,"statename":"stepsize","change":1,"reader":readint,"setfunction":StepSizeMotor,"writer":writeint},

"m2sp_tb":{"motor":2,"statename":"speed","change":1,"reader":readint,"setfunction":SetSpeedMotor,"writer":writeint},
"m2ac_tb":{"motor":2,"statename":"acceleration","change":1,"reader":readint,"setfunction":SetAccelerationMotor,"writer":writeint},
"m2sm_tb":{"motor":2,"statename":"stepsize","change":1,"reader":readint,"setfunction":StepSizeMotor,"writer":writeint},


};


var presetids=Object.keys(presetspane);


function flushmotorchanges()
{
 var i;
 var lmotor;
 var obj;
 var value;

 for(i=0;i<presetids.length;i++)
 {
  obj=presetspane[presetids[i]];
  if(obj.change)
  {
   lmotor=obj.motor;   
   value=state.motor[lmotor][obj.statename];
   obj.setfunction(lmotor,value);
   obj.change=0;
  }
 }
}




function paneinput()
{
 var obj=presetspane[$(this).attr("id")];
 var v;
 
 v=obj.reader($(this).val());
 if(!isNaN(v))
 {    
  obj.change=1;
  state.motor[obj.motor][obj.statename]=v;
 } 
}



for(var i=0;i<presetids.length;i++)
{
 $("#"+presetids[i]).on('input',paneinput);
}




function StartSeq()
{
 ssend("qs");
}


function EndSeq()
{
 ssend("qe");
}


function FireSeq()
{
 ssend("qf");
}


function SetSeq()
{
 ssend("qv "+sequencevalues.NoOfImages.toString()+" "+sequencevalues.StepsPerImage.toString()+" "+
             sequencevalues.DurationOfRun.toString()+" "+sequencevalues.CameraSettleTime.toString()+" "+" "+sequencevalues.ExposureDelay.toString());
 ssend("qw "+sequencevalues.FireButtonDelay.toString()+" 0 0 0");
}


sequencevalues=
{
 "NoOfImages":10,
 "StepsPerImage":10,
 "DurationOfRun":10,
 "CameraSettleTime":10,
 "ExposureDelay":10,
 "FireButtonDelay":10   
};


sequencepane=
{
 "noofpics_tb":{"change":1,"name":"NoOfImages","reader":readint,"setfunction":SetSeq,"writer":writeint},
 "stepsperpic_tb":{"change":1,"name":"StepsPerImage","reader":readfloat,"setfunction":SetSeq,"writer":writefloat},
 "rundur_tb":{"change":1,"name":"DurationOfRun","reader":readint,"setfunction":SetSeq,"writer":writeint},
 "sett_tb":{"change":1,"name":"CameraSettleTime","reader":readint,"setfunction":SetSeq,"writer":writeint},
 "edel_tb":{"change":1,"name":"ExposureDelay","reader":readint,"setfunction":SetSeq,"writer":writeint},
 "fphigh_tb":{"change":1,"name":"FireButtonDelay","reader":readint,"setfunction":SetSeq,"writer":writeint}
};


var sequenceids=Object.keys(sequencepane);


function sequencepaneinput()
{
 var obj=sequencepane[$(this).attr("id")];
 obj.change=1;
 sequencevalues[obj.name]=obj.reader($(this).val());
}



for(var i=0;i<sequenceids.length;i++)
{
 $("#"+sequenceids[i]).on('input',sequencepaneinput);
}




function SetMotorSeq()
{
 var motor;
 
 for(motor=0;motor<3;motor++)
 {
  ssend("qm "+motor.toString()+" "+
              seqsetvalues.motor[motor].Use.toString()+" "+
              seqsetvalues.motor[motor].MoveIn.toString()+" "+
              seqsetvalues.motor[motor].StepLength.toString()+" "+
              seqsetvalues.motor[motor].DelayBeforeFirstMove.toString()+" "+
              seqsetvalues.motor[motor].RampUp.toString()+" "+
              seqsetvalues.motor[motor].NumberOfSteps.toString()+" "+
              seqsetvalues.motor[motor].DelayAfterLastMove.toString()+" "+
              seqsetvalues.motor[motor].RampDown.toString());
   
 }
    
}

function readcheckbox(v)
{
 return(v?1:0);   
}

function writecheckbox(v)
{
 return(v!=0);   
}


seqsetvalues=
{
 "motor":[   
          {"Use":1,"MoveIn":1,"StepLength":10,"DelayBeforeFirstMove":10,"RampUp":10,"NumberOfSteps":10,"DelayAfterLastMove":10,"RampDown":10},
          {"Use":1,"MoveIn":1,"StepLength":10,"DelayBeforeFirstMove":10,"RampUp":10,"NumberOfSteps":10,"DelayAfterLastMove":10,"RampDown":10},
          {"Use":1,"MoveIn":1,"StepLength":10,"DelayBeforeFirstMove":10,"RampUp":10,"NumberOfSteps":10,"DelayAfterLastMove":10,"RampDown":10}
         ]
};


seqsetuppane=
{
 "m0on_cb":{"motor":0,"change":1,"name":"Use","reader":readcheckbox,"setfunction":SetMotorSeq,"writer":writecheckbox},    
 "m0movin_cb":{"motor":0,"change":1,"name":"MoveIn","reader":readcheckbox,"setfunction":SetMotorSeq,"writer":writecheckbox},
 "m0sl_tb":{"motor":0,"change":1,"name":"StepLength","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m0dfm_tb":{"motor":0,"change":1,"name":"DelayBeforeFirstMove","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m0ru_tb":{"motor":0,"change":1,"name":"RampUp","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
// "m0nos_tb":{"motor":0,"change":1,"name":"NumberOfSteps","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m0dlm_tb":{"motor":0,"change":1,"name":"DelayAfterLastMove","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m0rd_tb":{"motor":0,"change":1,"name":"RampDown","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 
 "m1on_cb":{"motor":1,"change":1,"name":"Use","reader":readcheckbox,"setfunction":SetMotorSeq,"writer":writecheckbox},    
 "m1movin_cb":{"motor":1,"change":1,"name":"MoveIn","reader":readcheckbox,"setfunction":SetMotorSeq,"writer":writecheckbox},
 "m1sl_tb":{"motor":1,"change":1,"name":"StepLength","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m1dfm_tb":{"motor":1,"change":1,"name":"DelayBeforeFirstMove","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m1ru_tb":{"motor":1,"change":1,"name":"RampUp","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
// "m1nos_tb":{"motor":1,"change":1,"name":"NumberOfSteps","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m1dlm_tb":{"motor":1,"change":1,"name":"DelayAfterLastMove","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m1rd_tb":{"motor":1,"change":1,"name":"RampDown","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},

 "m2on_cb":{"motor":2,"change":1,"name":"Use","reader":readcheckbox,"setfunction":SetMotorSeq,"writer":writecheckbox},    
 "m2movin_cb":{"motor":2,"change":1,"name":"MoveIn","reader":readcheckbox,"setfunction":SetMotorSeq,"writer":writecheckbox},
 "m2sl_tb":{"motor":2,"change":1,"name":"StepLength","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m2dfm_tb":{"motor":2,"change":1,"name":"DelayBeforeFirstMove","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m2ru_tb":{"motor":2,"change":1,"name":"RampUp","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
// "m2nos_tb":{"motor":2,"change":1,"name":"NumberOfSteps","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m2dlm_tb":{"motor":2,"change":1,"name":"DelayAfterLastMove","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 "m2rd_tb":{"motor":2,"change":1,"name":"RampDown","reader":readint,"setfunction":SetMotorSeq,"writer":writeint},
 
 
 
};



var seqsetids=Object.keys(seqsetuppane);


function seqsetuppaneinput()
{
 var obj=seqsetuppane[$(this).attr("id")];
 obj.change=1;
 seqsetvalues.motor[obj.motor][obj.name]=obj.reader($(this).val());
}



function seqsetuppanecheckbox()
{
 var obj=seqsetuppane[$(this).attr("id")];
 obj.change=1;
 seqsetvalues.motor[obj.motor][obj.name]=obj.reader($(this).prop('checked')==true); 
}



for(var i=0;i<seqsetids.length;i++)
{
 if(seqsetuppane[seqsetids[i]].reader==readcheckbox)
 {
  $("#"+seqsetids[i]).change(seqsetuppanecheckbox);      
 }
 else
 {    
  $("#"+seqsetids[i]).on('input',seqsetuppaneinput);
 } 
}


// run sequence

$("#runseq_btn").click(function()
{
 flushmotorchanges();
 SetWayPoints();
 SetSeq();
 SetMotorSeq();
 StartSeq();    
});



// firec_btn

$("#firec_btn").click(function()
{
 FireSeq();    
});



// endseq_btn

$("#endseq_btn").click(function()
{
 EndSeq();    
});



$("#gtallz_btn").click(function()
{
 flushmotorchanges();
 for(i=0;i<3;i++)
 {
  MoveToMotor(i,0); 
 }
});



$("#stallz_btn").click(function()
{
 for(i=0;i<3;i++)
 {
  SetCurPos(i,0);
  rxmovelo(i,0); 
 }
});


waypoints=[[0,0,0,0,0],[0,0,0,0,0],[0,0,0,0,0]];


function SetWayPoints()
{
 var s;
 var i;
 var j;
 
 for(j=0;j<3;j++)
 {
  s="wp "+j.toString();
  for(i=0;i<5;i++) 
  {
   s=s+" "+waypoints[j][i].toString();
  }
  ssend(s);
 }
}


function calcsteplength(lmotor)
{
 v=Math.round((waypoints[lmotor][4]-waypoints[lmotor][0])/sequencevalues.NoOfImages);

 if(v<0)
 {
  seqsetvalues.motor[lmotor].StepLength=-v;
  seqsetvalues.motor[lmotor].MoveIn=1;
 } 
 else 
 {
  seqsetvalues.motor[lmotor].StepLength=v;
  seqsetvalues.motor[lmotor].MoveIn=0;
 }

 updatesequencemotorvalue("StepLength",lmotor);
 updatesequencemotorvalue("MoveIn",lmotor);
}



function writewaypoints()
{
 $("#setend_btn").text(waypoints[motor][4].toString());    
 $("#setstart_btn").text(waypoints[motor][0].toString());    
 $("#wp1_btn").text(waypoints[motor][1].toString());
 $("#wp2_btn").text(waypoints[motor][2].toString());
 $("#wp3_btn").text(waypoints[motor][3].toString());
}


$("#setend_btn").click(function()
{
 var v;

 if(!sequencevalues.NoOfImages)
 {
  alert("Bad number of images");
  return;
 }
 
 waypoints[motor][4]=motorposn(motor);
 calcsteplength(motor);
 $("#setend_btn").text(waypoints[motor][4].toString());
});


$("#setstart_btn").click(function()
{
 var v;

 if(!sequencevalues.NoOfImages)
 {
  alert("Bad number of images");
  return;
 }
 
 waypoints[motor][0]=motorposn(motor);
 calcsteplength(motor);
 $("#setstart_btn").text(waypoints[motor][0].toString());
});




$("#wp1_btn").click(function()
{
 var v;
 v=motorposn(motor);
 $("#wp1_btn").text(v.toString());
 waypoints[motor][1]=v;
});




$("#wp2_btn").click(function()
{
 var v;
 v=motorposn(motor);
 $("#wp2_btn").text(v.toString());
 waypoints[motor][2]=v; 
});




$("#wp3_btn").click(function()
{
 var v;

 v=motorposn(motor);
 $("#wp3_btn").text(v.toString());
 waypoints[motor][3]=v;
});






$("#tf_btn").click(function(event){
$("#abc").empty();
var i;

stack.sort();

for(i=0;i<stack.length;i++)
{    
 $("#abc").append('<li><a href="#">'+stack[i]+'</a></li>');
}


//http://stackoverflow.com/questions/18855132/close-bootstrap-dropdown-after-link-click

$('#abc li a').click(function (e) {
  $(this).closest(".dropdown-menu").prev().dropdown("toggle");
  $('#text_tf').val($(this).text());
  e.preventDefault();
  return false;
});



});


$("#save_s").click(function(e){
  $(this).closest(".dropdown-menu").prev().dropdown("toggle");

  var name=$('#text_tf').val();
  if(name=="") alert("Name for settings file needed");
  else
  {
   flushmotorchanges();
   SetSeq();
   SetMotorSeq();
   ssend("sa "+name);   
  }
                   
  e.preventDefault();
  return false;
});



$("#load_s").click(function(e){
  $(this).closest(".dropdown-menu").prev().dropdown("toggle");

  var name=$('#text_tf').val();
  if(name=="") alert("Name for settings file needed");
  else
  {
   ssend("ld "+name);   
  }
                   
  e.preventDefault();
  return false;
});



$("#save_d").click(function(e){
  $(this).closest(".dropdown-menu").prev().dropdown("toggle");

  flushmotorchanges();
  SetSeq();
  SetMotorSeq();
  ssend("sa default");   
                   
  e.preventDefault();
  return false;
});



$("#load_d").click(function(e){
  $(this).closest(".dropdown-menu").prev().dropdown("toggle");
  ssend("ld default");   
                   
  e.preventDefault();
  return false;
});



$("#shutdown_d").click(function(e){
//  $(this).closest(".dropdown-menu").prev().dropdown("toggle");
 $('#myModal').modal('hide');
  ssend("sd 5000");   
                   
  e.preventDefault();
  return false;
});




// Start up

ssend("ld");
ssend("ps 0");
ssend("ps 1");
ssend("ps 2");
ssend("qq");
ssend("ls");
writewaypoints();


